<script setup lang="ts">
import { ref, type Ref } from 'vue';
import axios, { type AxiosResponse } from 'axios';
import { RouterLink } from 'vue-router';
import router from '../router/index';
import { useCookies } from "vue3-cookies";

const { cookies } = useCookies();
let email = ref();
let password = ref();
const backendURL = import.meta.env.VITE_BACKEND_URL;

async function sendFormFunc(email: Ref, password: Ref) {
    return await axios.post(`${backendURL}/auth/login`, {
        "email": email.value,
        "password": password.value
    });
};

let postMethod = async function () {
    sendFormFunc(email, password)
        .then((response) => {
            var expires: string;
            var token: string;
            expires = new Date(Date.now() + (1 * 24 * 60 * 60 * 1000)).toUTCString();
            expires = "; expires=" + expires + "; ";
            token = response.data.token;
            const role = response.data.role
            // document.cookie = "authorization=" + token + "; " + expires + "path=/";
            cookies.set("authorization", token)
            cookies.set("role", role)
            cookies.set("email", response.data.email)
            // @ts-ignore
            router.push("/");
        }).catch((error) => {
            switch (error.response.status) {
                case 401:
                    alert(error.response.data);
                    break;
                default:
                    alert("Ada gangguan di server. Silakan coba beberapa saat lagi.")
                    break;
            }
        });
}

let emailVal = (e: Event) => {
    email.value = (<HTMLInputElement>e?.target).value
}

let passwordVal = (e: Event) => {
    password.value = (<HTMLInputElement>e?.target).value
}

</script>

<template>
    <div class="text-center animate__animated animate__fadeIn flex flex-col">
        <div class="flex flex-row font-register md:[min-height:94vh] min-h-screen items-stretch">
            <div class="pt-10 px-3 w-full md:basis-1/3 bg-white">
                <p class="text-emerald-500 font-judul-regis-login ml-3 font-medium">
                    Login
                </p>
                <p class="label-regis-login ml-3 mt-3 text-base text-black" style="display:flex;">Login untuk mengunduh
                    buku</p>
                <form @submit.prevent="postMethod">
                    <div class="field">
                        <div class="grid grid-cols-1 pt-3">
                            <div>
                                <p class="label-regis-login text-base">Email*</p>
                                <input id="input-email" @input="emailVal" type="email"
                                    placeholder="some-email@server.com" required
                                    class="bg-white border border-neutral-400 p-2 rounded-2xl w-full mb-3" />
                            </div>
                            <div>
                                <p class="label-regis-login text-base">Password*</p>
                                <input id="input-password" @input="passwordVal" type="password"
                                    placeholder="Make sure it's secure!" required
                                    class="bg-white border border-neutral-400 p-2 rounded-2xl w-full mb-8" />
                            </div>
                        </div>
                        <button class="bg-green-400 text-white rounded-full p-3 w-full hover:bg-green-600" type="submit">Login</button>
                    </div>
                </form>
                <p class="content-center text-neutral-400 mb-5 text-base">atau
                </p>
                <RouterLink to="/register">
                    <button id="btn-regis" class="bg-sky-500 text-white rounded-full p-3 [width:95%] hover:bg-sky-600">
                        Register
                    </button>
                </RouterLink>

            </div>
            <div id="right-side" class="hidden md:block basis-2/3 right-side-regis-login px-5 py-auto">
                <div class="flex flex-col justify-center h-full">
                    <p class="py-0 my-0" style="color: #FFFFFF;">
                        سَيلاماتْ داتانْࢴْ
                    </p>
                    <p style="color: #FFFFFF;">
                        Pegonizer, solusi cepat dan mudah untuk pegiat Pegon.
                    </p>
                    <p style="color: #FFFFFF;">
                        Cari bentuk lain dari huruf Abjad Pegon dengan fitur Transliterator.
                    </p>
                    <p style="color: #FFFFFF;">
                        Gunakan Katalog Korpus untuk mencari referensi buku dalam Abjad Pegon.
                    </p>
                </div>
            </div>
        </div>
    </div>
</template>
